/* ===================================================================
 * MealShoppingListForm.java
 * 
 * Created Oct 4, 2004 12:32:26 PM
 * 
 * Copyright (c) 2004 Matt Magoffin (spamsqr@msqr.us)
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: MealShoppingListForm.java 28 2009-05-04 01:19:45Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.biz.BizContext;
import magoffin.matt.ieat.domain.Meal;
import magoffin.matt.ieat.domain.Recipe;
import magoffin.matt.ieat.domain.System;
import magoffin.matt.ieat.domain.UiData;
import magoffin.matt.ieat.util.MealCommand;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.ModelAndView;

/**
 * Form controller for generating meal shopping list.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 28 $ $Date: 2009-05-04 13:19:45 +1200 (Mon, 04 May 2009) $
 */
public class MealShoppingListForm extends AbstractEatForm {
	
	@SuppressWarnings("unchecked")
	@Override
	protected Map referenceData(HttpServletRequest request, Object command,
			Errors errors) throws Exception {
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		
		// add list of systems
		UiData ui = getDomainObjectFactory().getUiDataInstance();
		m.put("uidata",ui);
		List<System> l = recipeBiz.getAvailableUnitSystems();
		ui.getSystem().addAll(l);
		
		// add meal
		BizContext context = WebUtil.getBizContext(request, true);
		MealCommand mealCommand = (MealCommand)command;
		Meal meal = recipeBiz.getMealById(mealCommand.getMealId(),context);
		ui.getMeal().add(meal);
		
		return m;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {
		MealCommand mealCommand = (MealCommand)command;
		Map<String, Object> model = errors.getModel();

		BizContext context = WebUtil.getBizContext(request, true);
		Meal meal = recipeBiz.getMealById(mealCommand.getMealId(),context);
		Recipe r = recipeBiz.generateShoppingList(mealCommand.getMealId(),
				mealCommand.getSystemId(),context);
		
		UiData ui = getDomainObjectFactory().getUiDataInstance();
		ui.setMode("converted");
		ui.getRecipe().add(r);
		ui.getMeal().add(meal);
		
		model.put(WebConstants.DEFALUT_MODEL_OBJECT,ui);
		return new ModelAndView(getSuccessView(),model);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	protected ModelAndView processCancel(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors) {
		MealCommand mealCommand = (MealCommand)command;
		Map<String, Object> model = errors.getModel();
		WebUtil.saveMealCommand(model,mealCommand);
		return new ModelAndView(getCancelView(),model);
	}
	
}
